// C Source File
// Created 23/11/2002; 14:18:55


//COMPILE ONE CALC AT A TIME (0 : TI-89 or 1 : TI-92+ or V200)//
#if 0
	#define USE_TI92PLUS          // Compile for TI-92 Plus
	#define USE_V200              // Compile for V200

	// Macros
	
	#define GRIDX 1
	#define GRIDY 0
	#define TILE_WIDTH 16

	// hlp_msg
	#define HLP_MSG(str1,str2) FontSetSys( F_6x8); SetPlane(DARK_PLANE); DrawStr (0, 112,str1,A_NORMAL); DrawStr (0, 120,str2,A_NORMAL); SetPlane(LIGHT_PLANE); DrawStr (0, 112,str1,A_NORMAL); DrawStr (0, 120,str2,A_NORMAL);
#else
	#define USE_TI89              // Compile for TI-89

	// Macros
	
	#define GRIDX 10
	#define GRIDY 4
	#define TILE_WIDTH 11
	
	// hlp_msg
	#define HLP_MSG(str1,str2) FontSetSys( F_4x6); SetPlane(DARK_PLANE); DrawStr (0, 86,str1,A_NORMAL); DrawStr (0, 93,str2,A_NORMAL); SetPlane(LIGHT_PLANE); DrawStr (0, 86,str1,A_NORMAL); DrawStr (0, 93,str2,A_NORMAL);

#endif

#define KEY_PLUS '+'
#define KEY_MINUS '-'
	
#define GAME_NAME "Cogitus"
#define VER "v0.21"
#define EMAIL "antoinecellerier@yahoo.com"


#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files





/* -GLOBAL VARS- */
char isnew=0;
int sm=11;
char gm[49]={};
char nl[9]={};
char n[8]={};


	
/* -FUNCTIONS- */

// help function
void help(void)
{
	FontSetSys( F_4x6);
	GrayOff();
	clrscr();
	printf("%s %s\n%s %s\n\ncontact me: %s\n\n",GAME_NAME,VER,__DATE__,__TIME__,EMAIL);
	printf("KEYS:\n Arrows to change selected tile\n ENTER to drop number\n CLEAR or num pad to select dropable number\n F1 for help\n F2 to start a new game\n F3 to save and exit\n F4 regraph\n ESC to exit program");
	ngetchx();
	clrscr();
	printf("Version history:\n\n");
	printf("v0.10 : first playable version.\n Options such as saving games aren\'t available\n");
	printf("v0.11 : bugs fixed\n home screen & level selection added\n num pad tile selection\n");
	printf("v0.20 : save now possible\n (auto save at each move only)\n works only if program is unarchived\n");
	printf("v0.21 : added TI-92+ and V200 compatibility");
	ngetchx();
	GrayOn();
}

// select_level function
void select_level()
{
	
	char *numstr = (char *)malloc(10 * sizeof(char));
	
	SCR_RECT rect;
	
	sm=13;
	
	rect.xy.x0 = 30;
	rect.xy.y0 = 53;
	rect.xy.x1 = 100;
	rect.xy.y1 = 65;
	
	HLP_MSG("use - and + to select level","press ENTER to play");
	
	FontSetSys( F_6x8);
	
		while (TRUE) {
	
		sprintf (numstr, "level: %d", sm);
	
		SetPlane(LIGHT_PLANE);
		ScrRectFill(&rect, &rect, A_REVERSE);
		DrawStr (30, 54,numstr,A_NORMAL);
		SetPlane(DARK_PLANE);
		ScrRectFill(&rect, &rect, A_REVERSE);
		DrawStr (30, 54,numstr,A_NORMAL);
	
		switch (ngetchx()) {
			case KEY_MINUS:
			case KEY_LEFT:
			case KEY_DOWN:
			sm--;
			break;
			
			case KEY_PLUS:
			case KEY_RIGHT:
			case KEY_UP:
			sm++;
			break;
			
			case KEY_ESC:
			case KEY_ENTER:
			free(numstr);
			return;
		}
		
		if (sm<10) sm=99;
		if (sm>99) sm=10;
	}	
}

// welcome_scr function
void welcome_scr(void)
{
		FontSetSys(F_8x10);
		SetPlane(LIGHT_PLANE);
		ClrScr();
		DrawStr (1, 11,GAME_NAME,A_NORMAL);
		SetPlane(DARK_PLANE);
		ClrScr();
		DrawStr (0, 10,GAME_NAME,A_NORMAL);
		FontSetSys(F_6x8);
		DrawStr (0, 23,VER,A_NORMAL);
		DrawStr (0, 32,EMAIL,A_NORMAL);
}

// draw_tile function
// (column,row,tag)
void draw_tile(int a, int b, int num)
{
	char *numstr = (char *)malloc(10 * sizeof(char));
	SCR_RECT rect;
	rect.xy.x0 = GRIDX+TILE_WIDTH*a+1;
	rect.xy.y0 = GRIDY+TILE_WIDTH*b+1;
	rect.xy.x1 = GRIDX+TILE_WIDTH*(a+1)-1;
	rect.xy.y1 = GRIDY+TILE_WIDTH*(b+1)-1;

	sprintf (numstr, "%d", num);
	SetPlane(LIGHT_PLANE);
	ScrRectFill(&rect, &rect, A_NORMAL);
	DrawLine (GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*(b+1)-1, GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*b+1, A_NORMAL);
	DrawLine (GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*(b+1)-1, GRIDX+TILE_WIDTH*a+1, GRIDY+TILE_WIDTH*(b+1)-1, A_NORMAL);
	SetPlane(DARK_PLANE);
	DrawLine (GRIDX+TILE_WIDTH*a, GRIDY+TILE_WIDTH*b, GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*b, A_NORMAL);
	DrawLine (GRIDX+TILE_WIDTH*a, GRIDY+TILE_WIDTH*b, GRIDX+TILE_WIDTH*a, GRIDY+TILE_WIDTH*(b+1)-1, A_NORMAL);
	DrawLine (GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*(b+1)-1, GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*b+1, A_NORMAL);
	DrawLine (GRIDX+TILE_WIDTH*(a+1)-1, GRIDY+TILE_WIDTH*(b+1)-1, GRIDX+TILE_WIDTH*a+1, GRIDY+TILE_WIDTH*(b+1)-1, A_NORMAL);
	if (num!=0) {
		FontSetSys((CALCULATOR?F_8x10:F_6x8));
		DrawStr (GRIDX+TILE_WIDTH*a+2+(CALCULATOR?1:0), GRIDY+TILE_WIDTH*b+2+(CALCULATOR?1:0),numstr,A_NORMAL);
	}
	free(numstr);
	return;
}

// erase_tile function
// (column,row)
void erase_tile(int a, int b)
{
	SCR_RECT rect;
	rect.xy.x0 = GRIDX+TILE_WIDTH*a;
	rect.xy.y0 = GRIDY+TILE_WIDTH*b;
	rect.xy.x1 = GRIDX+TILE_WIDTH*(a+1)-1;
	rect.xy.y1 = GRIDY+TILE_WIDTH*(b+1)-1;

	SetPlane(LIGHT_PLANE);
	ScrRectFill(&rect, &rect, A_REVERSE);
	SetPlane(DARK_PLANE);
	ScrRectFill(&rect, &rect, A_REVERSE);
	return;
}

// select_tile function
// (column,row)
void select_tile(int a, int b)
{
	SCR_RECT rect;
	rect.xy.x0 = GRIDX+TILE_WIDTH*a;
	rect.xy.y0 = GRIDY+TILE_WIDTH*b;
	rect.xy.x1 = GRIDX+TILE_WIDTH*(a+1)-1;
	rect.xy.y1 = GRIDY+TILE_WIDTH*(b+1)-1;

	SetPlane(LIGHT_PLANE);
	ScrRectFill(&rect, &rect, A_XOR);
	SetPlane(DARK_PLANE);
	ScrRectFill(&rect, &rect, A_XOR);
	return;
}

// draw_grid function
void draw_grid()
{
	int i,j;
	for (i=0; i<7; i++) {
		for (j=0; j<7; j++) {
			draw_tile(i,j,gm[7*i+j]);
		}
	}
	return;
}

// draw_num function
void draw_num()
{
	int i;
	char *numstr = (char *)malloc(10 * sizeof(char));
	SCR_RECT rect;
	
	rect.xy.x0 = (CALCULATOR?120:89);
	rect.xy.y0 = GRIDY;
	rect.xy.x1 = (CALCULATOR?80+120:65+89);
	rect.xy.y1 = GRIDY+9;

	SetPlane(LIGHT_PLANE);
	ScrRectFill(&rect, &rect, A_REVERSE);
	SetPlane(DARK_PLANE);
	ScrRectFill(&rect, &rect, A_REVERSE);
	
	for (i=0; i<8; i++) {
		if (n[i]!=0) {
			sprintf (numstr, "%d", n[i]);
			(CALCULATOR?FontSetSys( F_8x10):FontSetSys( F_6x8));
			SetPlane(DARK_PLANE);
			DrawStr ((CALCULATOR?120:89)+(CALCULATOR?10:8)*i, GRIDY+1,numstr,A_NORMAL);
			SetPlane(LIGHT_PLANE);
			DrawStr ((CALCULATOR?120:89)+(CALCULATOR?10:8)*i, GRIDY+1,numstr,A_NORMAL);
		}
	}
	free(numstr);
}

// select_num function
void select_num(int k)
{
	SCR_RECT rect;
	rect.xy.x0 = (CALCULATOR?120:89)+(CALCULATOR?10:8)*k;
	rect.xy.y0 = GRIDY;
	rect.xy.x1 = (CALCULATOR?120:89)+(CALCULATOR?10:8)*(k+1)-1;
	rect.xy.y1 = GRIDY+(CALCULATOR?11:9);

	SetPlane(LIGHT_PLANE);
	ScrRectFill(&rect, &rect, A_XOR);
	SetPlane(DARK_PLANE);
	ScrRectFill(&rect, &rect, A_XOR);
}

// draw_num_left function
void draw_num_left()
{
	int i,j;
	char *numstr = (char *)malloc(10 * sizeof(char));
	SCR_RECT rect;
	
	rect.xy.x0 = (CALCULATOR?120:89);
	rect.xy.y0 = GRIDY+(CALCULATOR?12:10);
	rect.xy.x1 = (CALCULATOR?70:48)+(CALCULATOR?120:89);
	rect.xy.y1 = GRIDY+(CALCULATOR?52:40);
	
	FontSetSys((CALCULATOR?F_6x8:F_4x6));

	SetPlane(LIGHT_PLANE);
	ScrRectFill(&rect, &rect, A_REVERSE);
	DrawStr ((CALCULATOR?120:90), GRIDY+(CALCULATOR?13:11),"numbers left:",A_NORMAL);
	SetPlane(DARK_PLANE);
	ScrRectFill(&rect, &rect, A_REVERSE);
	DrawStr ((CALCULATOR?120:90), GRIDY+(CALCULATOR?13:11),"numbers left:",A_NORMAL);
		
	for (i=0; i<8; i++) {
		if (nl[i]!=0) {
			for (j=0; j<nl[i]; j++) {
				sprintf (numstr, "%d", i+1);
				SetPlane(DARK_PLANE);
				DrawStr ((CALCULATOR?120:90)+(CALCULATOR?8:6)*i, GRIDY+(CALCULATOR?21:17)+j*(CALCULATOR?8:6),numstr,A_NORMAL);
				SetPlane(LIGHT_PLANE);
				DrawStr ((CALCULATOR?120:90)+(CALCULATOR?8:6)*i, GRIDY+(CALCULATOR?21:17)+j*(CALCULATOR?8:6),numstr,A_NORMAL);
			}
		}
	}
	free(numstr);
}

// draw_level function
void draw_level()
{
	char *numstr = (char *)malloc(10 * sizeof(char));
	
	sprintf (numstr, "level: %d", sm);
	FontSetSys( F_6x8);

	SetPlane(LIGHT_PLANE);
	DrawStr ((CALCULATOR?120:90), GRIDY+(CALCULATOR?60:43),numstr,A_NORMAL);
	SetPlane(DARK_PLANE);
	DrawStr ((CALCULATOR?120:90), GRIDY+(CALCULATOR?60:43),numstr,A_NORMAL);
	
	free(numstr);
}

// horiz_sum function
int horiz_sum(int *a, int *b)
{
	int i,sum=0;
	
	i=*a+1;
	while (gm[7*i+*b]!=0 && i<=6){
		sum += gm[7*(i++)+*b];
	}
	
	i=*a-1;
	while (gm[7*i+*b]!=0 && i>=0){
		sum += gm[7*(i--)+*b];
	}
	
	return sum;
}

// vert_sum function
int vert_sum(int *a, int *b)
{
	int i,sum=0;
	
	i=*b+1;
	while (gm[7*(*a)+i]!=0 && i<=6){
		sum += gm[7*(*a)+(i++)];
	}
	
	i=*b-1;
	while (gm[7*(*a)+i]!=0 && i>=0){
		sum += gm[7*(*a)+(i--)];
	}
	
	return sum;
}

// regraph function
void regraph (int *a, int *b, int *k) {
	SetPlane(LIGHT_PLANE);
	clrscr();
	SetPlane(DARK_PLANE);
	clrscr();
	draw_grid();
	select_tile(*a,*b);
	draw_num();
	select_num(*k);
	draw_num_left();
	draw_level();
	HLP_MSG("Cogitus - ESC exit program","F1 help - F2 new game - F3 save and exit");
}

// init function
void init()
{
	int i,j;
	
	for (i=0;i<7;i++) {
		for (j=0;j<7;j++) {
			gm[7*i+j] = 0;
		}
	}
	
	for (i=0;i<8;i++) {
		nl[i]=4;
	}
	
	nl[8] = 24;
	
	randomize();
	for (i=0;i<8;i++) {
		do{
			j=random(8);
		} while (nl[j]==0);
		n[i]=j+1;
		nl[j]--;
	}
}

// game function
int game(void)
{
	// var declarations
	/* remember to free malloc/realloc/calloc vars!! */
	int a=0;
	int b=0;
	int a2,b2;
	int k=0;

	int key;
	
	int j;
	
	welcome_scr();
	
	if(isnew==0) {
		select_level();
		init();
	} else {
		HLP_MSG("game loaded...","press a key to play");
		ngetchx();
	}
	
	regraph(&a,&b,&k);
	
	
	// game loop
	while (TRUE) {
		
		a2 = a;
		b2 = b;
			
		//keyboard input switch
		switch (key=ngetchx())
		{
			case KEY_UP:
			b = (b+6)%7;
			break;
			
			case KEY_RIGHT:
			a = (a+1)%7;
			break;
			
			case KEY_DOWN:
			b = (b+1)%7;
			break;
			
			case KEY_LEFT:
			a = (a+6)%7;
			break;
			
			case KEY_CLEAR:
			select_num(k);
			k = (k+1)%8;
			select_num(k);
			break;
			
			case 49:
			case 50:
			case 51:
			case 52:
			case 53:
			case 54:
			case 55:
			case 56:
			select_num(k);
			k = key - 49;
			select_num(k);
			break;				
			
			case KEY_ENTER:
			if (gm[7*a+b] == 0
			    && (((a<1?FALSE:gm[7*(a-1)+b]!=0) 
			         || (b<1?FALSE:gm[7*a+b-1]!=0)
			         || (a>5?FALSE:gm[7*(a+1)+b]!=0)
			         || (b>5?FALSE:gm[7*a+b+1]!=0))
			        || nl[8] == 24)){
				if (vert_sum(&a,&b)+n[k]<=sm && horiz_sum(&a,&b)+n[k]<=sm) {
					gm[7*a+b]=n[k];
					select_num(k);
					if (nl[8]>0) {
						do{
							j=random(8);
						} while (nl[j]==0);
						n[k]=j+1;
						nl[j]--;
						nl[8]--;
						draw_num_left();
						draw_num();
						select_num(k);
					} else {
						n[k] = 0;
						draw_num();
						select_num(k);
						if (n[0]+n[1]+n[2]+n[3]+n[4]+n[5]+n[6]+n[7]==0) {
							isnew=0;
							return TRUE;
						}
					}
				}
			}
			break;
			
			case KEY_F1:
			help();
			regraph(&a,&b,&k);
			break;
			
			case KEY_F2:
			isnew=0;
			welcome_scr();
			select_level();
			init();
			a=0;
			b=0;
			k=0;
			regraph(&a,&b,&k);
			break;
			
			case KEY_F3:
			isnew=1;
			return FALSE;
			break;
			
			case KEY_F4:
			regraph(&a,&b,&k);
			break;			
			
			case KEY_ESC:
			return FALSE;
			break;
			
			default:
			break;		
		}
		

		erase_tile(a2,b2);
		draw_tile(a2,b2,gm[7*a2+b2]);
		select_tile(a,b);

		
	}
}

// Main Function
void _main(void)
{
	
	
	//switching to Gray Scale mode and Error Message if it fails
	if (!GrayOn()) {
		clrscr();
		FontSetSys( F_6x8);
		printf("%s %s: Error\n
		could not switch\n
		to gray mode\n\n
		for help email me at:\n
		%s\n\n
		press a key...",GAME_NAME,VER,EMAIL);
		ngetchx();
		return;
	}
	
	
	//start Game
	if(game()) {
		GrayOff(); //Swithching Gray Scale mode off
		clrscr();
		FontSetSys( F_6x8);
		printf("You win!");
	} else {
		GrayOff(); //Swithching Gray Scale mode off
		clrscr();
		FontSetSys( F_6x8);
		printf("You lose!");
	}
		printf("\n\n__________________________\n\n%s %s\n%s %s\n\n%s",GAME_NAME,VER,__DATE__,__TIME__,EMAIL);
	
	/*OSInitBetweenKeyDelay(336);
	OSInitKeyInitDelay(49);*/
	ngetchx();
	
	
	
	return;
}
